<?php

/**
 * inf_nov_personal actions.
 *
 * @package    nomina
 * @subpackage inf_nov_personal
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nov_personalActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_novedad, fecha_inicial, num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            
            $anho_mes_ini = $request['anho_mes_ini'];
            $anho_mes_fin = $request['anho_mes_fin'];
            
            $tipo_filtro = $request['tipo_filtro'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Novedades
            if (isset($request['id_novedad'])) {
                $whereNovedades = " AND tab0.id_novedad = " . $request['id_novedad'];
            } else {
                $whereNovedades = ' ';
            }
            
            //estado
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            } else {
                $whereEstado = ' ';
            }
            
            


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select distinct
tab0.*,
case when tab0.id_tipo_novedad != 1 then tab0.fecha_terminacion else null end as fecha_fin,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro ) AS PERIODO

from(

select 
tab3.codigo as codigo_ini,
tab4.codigo as codigo_fin,
tab1.*,
tab2.nombre_apellido, tab3.componente AS CARGO1, tab3.asignacion_basica AS ASIGNA1,
tab4.componente as cargo2, tab4.asignacion_basica as asigna2,
tab5.descripcion AS NOVEDAD,
tab5.id_tipo_novedad, nombra.fecha_ingreso,
per.anho_mes,
per.periodo as periodo_nov

from no_novedad_personal tab1

    left join no_periodo_v per
    on per.id_periodo = tab1.id_periodo
                    
left join no_novedades tab5 ON tab5.id_novedad = tab1.id_novedad

left join no_datos_funcionario_v tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc

left join no_dp_v tab3 ON tab3.id_dp = tab1.id_dp_ini
left join no_dp_v tab4 ON tab4.id_dp = tab1.id_dp_fin

left join (
  SELECT
   aut.*,
   ROW_NUMBER() OVER (
    partition by aut.num_doc
    ORDER BY aut.estado DESC, aut.fecha_ingreso DESC
   ) AS rn
  from no_nombramiento aut
)nombra
on nombra.id_tipo_doc = tab1.id_tipo_doc
and nombra.num_doc = tab1.num_doc
and nombra.rn = 1
/*
left join no_nombramiento nombra
on nombra.id_tipo_doc = tab1.id_tipo_doc
and nombra.num_doc = tab1.num_doc
--and nombra.estado = 1
*/
/*
where
(nombra.estado = 1 or
    ( nombra.estado = 0
      and nombra.fecha_retiro
    between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $periodo_filtro) ,'dd/mm/yyyy')
    and trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $periodo_filtro) ,'dd/mm/yyyy') ))
    )
)
*/

)tab0

where
(
   ( tab0.fecha_inicial BETWEEN to_date('$fecha_ini' ,'yyyy-mm-dd') AND to_date('$fecha_fin' ,'yyyy-mm-dd') and 0 = $tipo_filtro )
    or
    ( tab0.anho_mes between $anho_mes_ini and $anho_mes_fin and 1 = $tipo_filtro )
)                                               
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereNovedades
$whereEstado

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select distinct
tab0.*,
case when tab0.id_tipo_novedad != 1 then tab0.fecha_terminacion else null end as fecha_fin,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro ) AS PERIODO

from(

select 
tab3.codigo as codigo_ini,
tab4.codigo as codigo_fin,
tab1.*,
tab2.nombre_apellido, tab3.componente AS CARGO1, tab3.asignacion_basica AS ASIGNA1,
tab4.componente as cargo2, tab4.asignacion_basica as asigna2,
tab5.descripcion AS NOVEDAD,
tab5.id_tipo_novedad, nombra.fecha_ingreso,
per.anho_mes,
per.periodo as periodo_nov

from no_novedad_personal tab1

    left join no_periodo_v per
    on per.id_periodo = tab1.id_periodo
                    
left join no_novedades tab5 ON tab5.id_novedad = tab1.id_novedad

left join no_datos_funcionario_v tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc

left join no_dp_v tab3 ON tab3.id_dp = tab1.id_dp_ini
left join no_dp_v tab4 ON tab4.id_dp = tab1.id_dp_fin

left join (
  SELECT
   aut.*,
   ROW_NUMBER() OVER (
    partition by aut.num_doc
    ORDER BY aut.estado DESC, aut.fecha_ingreso DESC
   ) AS rn
  from no_nombramiento aut
)nombra
on nombra.id_tipo_doc = tab1.id_tipo_doc
and nombra.num_doc = tab1.num_doc
and nombra.rn = 1
/*
left join no_nombramiento nombra
on nombra.id_tipo_doc = tab1.id_tipo_doc
and nombra.num_doc = tab1.num_doc
--and nombra.estado = 1
*/
/*
where
(nombra.estado = 1 or
    ( nombra.estado = 0
      and nombra.fecha_retiro
    between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $periodo_filtro) ,'dd/mm/yyyy')
    and trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $periodo_filtro) ,'dd/mm/yyyy') ))
    )
)
*/

)tab0

where
(
   ( tab0.fecha_inicial BETWEEN to_date('$fecha_ini' ,'yyyy-mm-dd') AND to_date('$fecha_fin' ,'yyyy-mm-dd') and 0 = $tipo_filtro )
    or
    ( tab0.anho_mes between $anho_mes_ini and $anho_mes_fin and 1 = $tipo_filtro )
)                    
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereNovedades
$whereEstado
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_nov_personal] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
